/*--------------------------------*
 |   TimeSync for the ChipCard    +-+
 |         Version J0.01          | |
 | Copyright (c) 1995 by Altair | |
 |      All rights reserved.      | |
 *-+------------------------------+ |
   +--------------------------------*
RpC@()
OS/2:   gcc TimeSync.c -o TimeSyn2.exe -Zomf -O2
DOS/V:  bcc -1+ -O1 -Ol -Og -Ol -Om -d+ -ms -M -a TimeSync.c
=====================================================
 Ver.      ύX
-----------------------------------------------------
 0.00   
 0.01   \[XxDOS/VłȂOS/2ɂΉ
        ݒlCHIPLDR.EXEoRœn悤ɕύX
        bItZbg̃fBtHg3b7bɕύX
        /KA/1A/2IvVǉ
====================================================*/
#ifdef __MSDOS__
#include<dos.h>
#else
#define INCL_DOSDATETIME
#include<os2.h>
#include<string.h>
#endif
#include<process.h>
#include<io.h>
#include<stdio.h>
#include<stdlib.h>

#ifdef __MSDOS__
#pragma option -a-
#else
#pragma pack(1)
#endif
struct ChipDateTime
{   unsigned short  Days;   /*ް̓ti1995/01/010Ƃoߓ)*/
    unsigned char   Hour;   /*ް̎ 24/12 "01/11"b+""b 6ޯ*/
    unsigned char   Minu;   /*ް̕*/
    unsigned char   Seco;   /*ް̕b*/
};
#ifdef __MSDOS__
#pragma option -a

#define LOADER  "CHIPLDR.EXE"
#else
#pragma pack()

#define LOADER  "CHIPLDR2.EXE"
#endif

#ifndef FALSE
#define FALSE   0
#endif
#ifndef TRUE
#define TRUE    1
#endif

#define CLOCK12  0xC0
#define CLOCK24  0x40
#define HF_STDOUT   1

#define help()                                                          \
    puts("\\:\tTIMESYNC  [}offset]  [/K]  [/1|/2]\t(DOS/V)\n"       \
         "\tTIMESYN2  [}offset]  [/K]  [/1|/2]\t(OS/2)\n\n"            \
         "}offset: ChipCardɐݒ肷鎞̕ilbŎw肵܂\n"   \
         "\t  ȗ(default)ĺA7bł\n\n"                     \
         "  /K:\t  ChipCardɃ[UvOo^΁A\n"  \
         "\t  Ȃ悤ɓw͂܂\n\n"                             \
         "  /1:\t  ChipCard̎v12ԐɃZbg܂\n\n"          \
         "  /2:\t  ChipCard̎v24ԐɃZbg܂(ȗ)\n")

#define ChipObj "\nS20810021C2185FF80A4\nS22410FF85CEC421CEC500FB9400FBCC00CE"\
                "C610C6C2FFCF29FBB800C680FFCEC700C700F044\nS22410FFA5B1054692"\
                "7093F5FBC61F02B600C6CBFFC50401FBB800FBDA00CEAEF1FD54696D93\n"\
                "S21210FFC56553796E6300446F6E652E2E2E0007\nS804000000FB\n"

int main(int argc,char**argv)
{   union
    {   struct ChipDateTime ChipDateTime;
        unsigned char DataByte[5];
    }ChipData;
    unsigned char DaysInMonth[12]={31,28,31,30,31,30,31,31,30,31,30,31};
    unsigned char ampm=CLOCK24,keep=FALSE;
    char*psa,*LoaderOut,*TempSeed="~SYNC",sa[2][128];
    FILE*fp;
#ifdef __MSDOS__
    struct date date;
    struct time time;
#define SysYear date.da_year
#define SysDay  date.da_day
#define SysMon  date.da_mon
#define SysHour time.ti_hour
#define SysMin  time.ti_min
#define SysSec  time.ti_sec
#else
    char*weekday[7]={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
    DATETIME DateTime;
#define SysYear DateTime.year
#define SysDay  DateTime.day
#define SysMon  DateTime.month
#define SysHour DateTime.hours
#define SysMin  DateTime.minutes
#define SysSec  DateTime.seconds
#endif
    short offset=7;
    int _stdout,i,k=0;

    puts("\n- TimeSync for the ChipCard - Version J0.01 (for "
#ifdef __MSDOS__
         "DOS/V"
#else
         "OS/2"
#endif
         ")\nCopyright (c) 1995 by Altair.  All rights reserved.\n");

    while(--argc>0)
        switch(*argv[argc])
        {   case'/':    switch(argv[argc][1])
                        {   case'?':    help();         return 0;
                            case'1':    ampm=CLOCK12;   break;
                            case'2':    ampm=CLOCK24;   break;
                            case'k':
                            case'K':    keep=TRUE;      break;
                            default:    fprintf(stderr,"Error: XCb`'%s'"
                                                "sł",argv[argc]);
                                        return 1;
                        };
                        break;
            default:    offset=atoi(argv[argc]+1);
        }

    if((psa=tempnam(NULL,TempSeed))==NULL){
TmpErr: fputs("Error: e|t@C܂\n",stderr);
        return 1;
    }
    if((fp=fopen(psa,"w"))==NULL)
        goto TmpErr;
    if(!keep)
        for(i=0x213;i<0x21C;i+=4)
            fprintf(fp,"S20510%04X0000\n",i);
    fputs("S20910FF80",fp);

#ifdef __MSDOS__
    getdate(&date);
    gettime(&time);
#else
    DosGetDateTime(&DateTime);
#endif
    printf(" %hu/%02hu/%02hu\n"
#ifndef __MSDOS__
           "\t%s\n"
#endif
           "   %02hu:%02hu:%02hu\n\n",SysYear,SysMon,SysDay,
#ifndef __MSDOS__
           weekday[DateTime.weekday],
#endif
           SysHour,SysMin,SysSec);

    ChipData.ChipDateTime.Days=(SysYear-1995)*365.25+.6;
    if(!(SysYear&0xF))
        DaysInMonth[1]=29;
    while(--SysMon>0)
        ChipData.ChipDateTime.Days+=DaysInMonth[SysMon-1];
    ChipData.ChipDateTime.Days+=SysDay-1;
    ChipData.ChipDateTime.Hour=SysHour|ampm;
    ChipData.ChipDateTime.Minu=SysMin;
    ChipData.ChipDateTime.Seco=SysSec+offset;
    for(i=0;i<5;fprintf(fp,"%02hX",ChipData.DataByte[i++]));
    fputs(ChipObj,fp);
    fclose(fp);

    if((LoaderOut=tempnam(NULL,TempSeed))==NULL)
        goto TmpErr;
    if((fp=fopen(LoaderOut,"w+"))==NULL)
        goto TmpErr;
    _stdout=dup(HF_STDOUT);
    dup2(fileno(fp),HF_STDOUT); /* Wo̧͂ق޲ڸ */

    i=spawnlp(P_WAIT,LOADER,*argv,psa,NULL);

    dup2(_stdout,HF_STDOUT);    /* ޲ڸĉ */
    remove(psa);
    free(psa);
    if(i!=-1)
    {   rewind(fp);
        while(fgets(sa[k],sizeof sa[k],fp)!=NULL)
            k=1-k;
    }
    fclose(fp);
    remove(LoaderOut);
    free(LoaderOut);
    fputs(i==-1?"Error: " LOADER "qvZXƂċNł܂ł\n"
               :sa[1-k],stderr);
    return i?1:0;
}
